#include <Isotronic.h>

/*
 * Decoding old remote control Isotronic Art.No. 586 08
 * sold by Pollin 101-075
 * 
 * tested on Arduino Uno
 * 
 * bits:
 *   short pulse abt. 640us
 *   long pulse abt. 1280us
 * protocol:
 * start condition: >60ms low, short high
 * 20 data bits: 
 *  1: short low, long high
 *  0: long low, short high
 *  
 * first 12 bits are the address, this is changed with each reset of the remote control 
 * last 8 bits are the key code
 */
 
#define RXPIN     2   // Input Pin 2 is interrupt 0 

isotronic iso ( RXPIN );

void setup() {
  Serial.begin ( 9600 );
  Serial.println ( "Test Isotronic" );
  attachInterrupt ( digitalPinToInterrupt(RXPIN), rxInterrupt, CHANGE ); 
}

void loop() {
  if ( iso.available() ) {
    Serial.print ( iso.getAddress(), HEX );
    Serial.print ( ' ' );
    Serial.println ( iso.getKeyText(iso.getKey()) );
    iso.release();
  }
}

void rxInterrupt() {
  iso.rxInterrupt();
}



//------------------------------------------------

