#ifndef _ISOTRONIC_H
#define _ISOTRONIC_H

#include <Arduino.h>

// valune of the last eig
#define ISO_1ON     238
#define ISO_1OFF    255
#define ISO_1UP     245
#define ISO_1DOWN   228

#define ISO_2ON     108
#define ISO_2OFF    125
#define ISO_2UP     119
#define ISO_2DOWN   102

#define ISO_3ON     175
#define ISO_3OFF    190
#define ISO_3UP     180
#define ISO_3DOWN   165

#define ISO_4ON     45
#define ISO_4OFF    60
#define ISO_4UP     54
#define ISO_4DOWN   39

#define ISO_ALLUP   20
#define ISO_ALLDOWN  5
#define ISO_ALLON   15
#define ISO_ALLOFF  30

class isotronic {
  public:
    isotronic( uint8_t pin = 2 );
    ~isotronic();
    uint8_t available();
    void release();
    uint16_t getLast();
    uint8_t getState();
    uint16_t getAddress();
    uint8_t getKey();
    const char *getKeyText ( uint8_t key );
    void rxInterrupt();
    
  private:
    uint8_t _state;
    uint8_t _ready;
    uint8_t _idx;
    uint8_t _key;
    uint8_t _pin;
    uint16_t _addr;
    uint16_t _last;
};

#endif
